Index: irc.c
===================================================================
--- irc.c	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ irc.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -864,124 +1540,34 @@
    pongs from the user. When not connected yet, we don't ping but drop the
    connection when the user fails to connect in IRC_LOGIN_TIMEOUT secs. */
-static gboolean irc_userping(gpointer _irc, gint fd, b_input_condition cond)
-{
-	double now = gettime();
+static gboolean irc_userping( gpointer _irc )
+{
 	irc_t *irc = _irc;
-	int fail = 0;
-
-	if (!(irc->status & USTATUS_LOGGED_IN)) {
-		if (now > (irc->last_pong + IRC_LOGIN_TIMEOUT)) {
-			fail = now - irc->last_pong;
-		}
-	} else {
-		if (now > (irc->last_pong + global.conf->ping_timeout)) {
-			fail = now - irc->last_pong;
-		} else {
-			irc_write(irc, "PING :%s", IRC_PING_STRING);
-		}
-	}
-
-	if (fail > 0) {
-		irc_abort(irc, 0, "Ping Timeout: %d seconds", fail);
+	int rv = 0;
+	
+	if( irc->status < USTATUS_LOGGED_IN )
+	{
+		if( gettime() > ( irc->last_pong + IRC_LOGIN_TIMEOUT ) )
+			rv = gettime() - irc->last_pong;
+	}
+	else
+	{
+		if( ( gettime() > ( irc->last_pong + global.conf->ping_interval ) ) && !irc->pinging )
+		{
+			irc_write( irc, "PING :%s", IRC_PING_STRING );
+			irc->pinging = 1;
+		}
+		else if( gettime() > ( irc->last_pong + global.conf->ping_timeout ) )
+		{
+			rv = gettime() - irc->last_pong;
+		}
+	}
+	
+	if( rv > 0 )
+	{
+		irc_write( irc, "ERROR :Closing Link: Ping Timeout: %d seconds", rv );
+		irc_free( irc );
 		return FALSE;
 	}
-
+	
 	return TRUE;
 }
-
-static char *set_eval_charset(set_t *set, char *value)
-{
-	irc_t *irc = (irc_t *) set->data;
-	char *test;
-	gsize test_bytes = 0;
-	GIConv ic, oc;
-
-	if (g_strcasecmp(value, "none") == 0) {
-		value = g_strdup("utf-8");
-	}
-
-	if ((oc = g_iconv_open(value, "utf-8")) == (GIConv) - 1) {
-		return NULL;
-	}
-
-	/* Do a test iconv to see if the user picked an IRC-compatible
-	   charset (for example utf-16 goes *horribly* wrong). */
-	if ((test = g_convert_with_iconv(" ", 1, oc, NULL, &test_bytes, NULL)) == NULL ||
-	    test_bytes > 1) {
-		g_free(test);
-		g_iconv_close(oc);
-		irc_rootmsg(irc, "Unsupported character set: The IRC protocol "
-		            "only supports 8-bit character sets.");
-		return NULL;
-	}
-	g_free(test);
-
-	if ((ic = g_iconv_open("utf-8", value)) == (GIConv) - 1) {
-		g_iconv_close(oc);
-		return NULL;
-	}
-
-	if (irc->iconv != (GIConv) - 1) {
-		g_iconv_close(irc->iconv);
-	}
-	if (irc->oconv != (GIConv) - 1) {
-		g_iconv_close(irc->oconv);
-	}
-
-	irc->iconv = ic;
-	irc->oconv = oc;
-
-	return value;
-}
-
-/* Mostly meant for upgrades. If one of these is set to the non-default,
-   set show_users of all channels to something with the same effect. */
-static char *set_eval_bw_compat(set_t *set, char *value)
-{
-	irc_t *irc = set->data;
-	char *val;
-	GSList *l;
-
-	irc_rootmsg(irc, "Setting `%s' is obsolete, use the `show_users' "
-	            "channel setting instead.", set->key);
-
-	if (strcmp(set->key, "away_devoice") == 0 && !bool2int(value)) {
-		val = "online,special%,away";
-	} else if (strcmp(set->key, "show_offline") == 0 && bool2int(value)) {
-		val = "online@,special%,away+,offline";
-	} else {
-		val = "online+,special%,away";
-	}
-
-	for (l = irc->channels; l; l = l->next) {
-		irc_channel_t *ic = l->data;
-		/* No need to check channel type, if the setting doesn't exist it
-		   will just be ignored. */
-		set_setstr(&ic->set, "show_users", val);
-	}
-
-	return SET_INVALID;
-}
-
-static char *set_eval_utf8_nicks(set_t *set, char *value)
-{
-	irc_t *irc = set->data;
-	gboolean val = bool2int(value);
-
-	/* Do *NOT* unset this flag in the middle of a session. There will
-	   be UTF-8 nicks around already so if we suddenly disable support
-	   for them, various functions might behave strangely. */
-	if (val) {
-		irc->status |= IRC_UTF8_NICKS;
-	} else if (irc->status & IRC_UTF8_NICKS) {
-		irc_rootmsg(irc, "You need to reconnect to BitlBee for this "
-		            "change to take effect.");
-	}
-
-	return set_eval_bool(set, value);
-}
-
-void register_irc_plugin(const struct irc_plugin *p)
-{
-	irc_plugins = g_slist_prepend(irc_plugins, (gpointer) p);
-}
Index: irc.h
===================================================================
--- irc.h	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ irc.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,9 +1,9 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2013 Wilmer van der Gaast and others                *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
   \********************************************************************/
 
-/* The IRC-based UI (for now the only one)                              */
+/* The big hairy IRCd part of the project                               */
 
 /*
@@ -20,6 +20,6 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
@@ -27,354 +27,121 @@
 #define _IRC_H
 
-#include <sys/socket.h>
-
 #define IRC_MAX_LINE 512
-#define IRC_MAX_ARGS 16
-#define IRC_WORD_WRAP 425
+#define IRC_MAX_ARGS 8
 
 #define IRC_LOGIN_TIMEOUT 60
 #define IRC_PING_STRING "PinglBee"
 
-#define UMODES "abisw"     /* Allowed umodes (although they mostly do nothing) */
-#define UMODES_PRIV "Ro"   /* Allowed, but not by user directly */
-#define UMODES_KEEP "R"    /* Don't allow unsetting using /MODE */
-#define CMODES "ntC"       /* Allowed modes */
-#define CMODE "t"          /* Default mode */
-#define UMODE "s"          /* Default mode */
+/* #define FLOOD_SEND 
+ * Not yet enabled by default due to some problems.
+ */
+#define FLOOD_SEND_INTERVAL 30
+#define FLOOD_SEND_BYTES (1024*10)
+#define FLOOD_SEND_MAXBUFFER (1024*20)
 
-#define CTYPES "&#"        /* Valid channel name prefixes */
+#define UMODES "ais"
+#define CMODES "nt"
+#define CMODE "t"
+#define UMODE "s"
 
-typedef enum {
-	USTATUS_OFFLINE = 0,
-	USTATUS_AUTHORIZED = 1, /* Gave the correct server password (PASS). */
-	USTATUS_LOGGED_IN = 2,  /* USER+NICK(+PASS) finished. */
-	USTATUS_IDENTIFIED = 4, /* To NickServ (root). */
-	USTATUS_SHUTDOWN = 8,   /* Now used to indicate we're shutting down.
-	                           Currently just blocks irc_vawrite(). */
-	USTATUS_CAP_PENDING = 16,
-	USTATUS_SASL_PLAIN_PENDING = 32,
-
-	/* Not really status stuff, but other kinds of flags: For slightly
-	   better password security, since the only way to send passwords
-	   to the IRC server securely (i.e. not echoing to screen or written
-	   to logfiles) is the /OPER command, try to use that command for
-	   stuff that matters. */
-	OPER_HACK_IDENTIFY = 0x100,
-	OPER_HACK_IDENTIFY_NOLOAD = 0x01100,
-	OPER_HACK_IDENTIFY_FORCE  = 0x02100,
-	OPER_HACK_REGISTER = 0x200,
-	OPER_HACK_ACCOUNT_PASSWORD = 0x400,
-	OPER_HACK_ANY = 0x3700, /* To check for them all at once. */
-
-	IRC_UTF8_NICKS = 0x10000, /* Disable ASCII restrictions on buddy nicks. */
+typedef enum
+{
+	USTATUS_OFFLINE,
+	USTATUS_AUTHORIZED,
+	USTATUS_LOGGED_IN,
+	USTATUS_IDENTIFIED
 } irc_status_t;
 
-typedef enum {
-	CAP_SASL = (1 << 0),
-	CAP_MULTI_PREFIX = (1 << 1),
-	CAP_EXTENDED_JOIN = (1 << 2),
-	CAP_AWAY_NOTIFY = (1 << 3),
-	CAP_USERHOST_IN_NAMES = (1 << 4),
-	CAP_SERVER_TIME = (1 << 5),
-} irc_cap_flag_t;
+typedef struct channel
+{
+	char *name;
+} channel_t;
 
-struct irc_user;
-
-typedef struct irc {
+typedef struct irc
+{
 	int fd;
 	irc_status_t status;
 	double last_pong;
 	int pinging;
-	GString *sendbuffer;
+	char *sendbuffer;
 	char *readbuffer;
-	GIConv iconv, oconv;
+	int quit;
 
-	struct irc_user *root;
-	struct irc_user *user;
-
-	char *password; /* HACK: Used to save the user's password, but before
-	                   logging in, this may contain a password we should
-	                   send to identify after USER/NICK are received. */
-	char *auth_backend;
-
-	char umode[8];
-
-	struct query *queries;
-	GSList *file_transfers;
-
-	GSList *users G_GNUC_DEPRECATED;
-	GSList *channels;
-	struct irc_channel *default_channel;
-	GHashTable *nick_user_hash;
-	GHashTable *watches; /* See irc_cmd_watch() */
-
-	gint r_watch_source_id;
-	gint w_watch_source_id;
-	gint ping_source_id;
-	gint login_source_id; /* To slightly delay some events at login time. */
-
-	struct otr *otr; /* OTR state and book keeping, used by the OTR plugin.
-	                    TODO: Some mechanism for plugindata. */
-
-	struct bee *b;
-	guint32 caps;
-} irc_t;
-
-typedef enum {
-	/* Replaced with iu->last_channel IRC_USER_PRIVATE = 1, */
-	IRC_USER_AWAY = 2,
-
-	IRC_USER_OTR_ENCRYPTED = 0x10000,
-	IRC_USER_OTR_TRUSTED   = 0x20000,
-} irc_user_flags_t;
-
-typedef struct irc_user {
-	irc_t *irc;
+	int sentbytes;
+	time_t oldtime;
 
 	char *nick;
 	char *user;
 	char *host;
-	char *fullname;
+	char *realname;
+	char *password;
 
-	/* Nickname in lowercase for case insensitive searches */
-	char *key;
+	char umode[8];
+	
+	char *myhost;
+	char *mynick;
 
-	irc_user_flags_t flags;
-	struct irc_channel *last_channel;
+	char *channel;
+	int c_id;
 
-	GString *pastebuf; /* Paste buffer (combine lines into a multiline msg). */
-	guint pastebuf_timer;
-	time_t away_reply_timeout; /* Only send a 301 if this time passed. */
-
-	struct bee_user *bu;
-
-	const struct irc_user_funcs *f;
-} irc_user_t;
-
-struct irc_user_funcs {
-	gboolean (*privmsg)(irc_user_t *iu, const char *msg);
-	gboolean (*ctcp)(irc_user_t *iu, char * const* ctcp);
-};
-
-extern const struct irc_user_funcs irc_user_root_funcs;
-extern const struct irc_user_funcs irc_user_self_funcs;
-
-typedef enum {
-	IRC_CHANNEL_JOINED = 1, /* The user is currently in the channel. */
-	IRC_CHANNEL_TEMP = 2,   /* Erase the channel when the user leaves,
-	                           and don't save it. */
-
-	/* Hack: Set this flag right before jumping into IM when we expect
-	   a call to imcb_chat_new(). */
-	IRC_CHANNEL_CHAT_PICKME = 0x10000,
-} irc_channel_flags_t;
-
-typedef struct irc_channel {
-	irc_t *irc;
-	char *name;
-	char mode[8];
-	int flags;
-
-	char *topic;
-	char *topic_who;
-	time_t topic_time;
-
-	GSList *users; /* struct irc_channel_user */
-	struct irc_user *last_target;
+	char is_private;		/* Not too nice... */
+	char *last_target;
+	
+	struct query *queries;
+	struct account *accounts;
+	
+	struct __USER *users;
+	GHashTable *userhash;
+	GHashTable *watches;
+	struct __NICK *nicks;
+	struct help *help;
 	struct set *set;
 
-	GString *pastebuf; /* Paste buffer (combine lines into a multiline msg). */
-	guint pastebuf_timer;
+	GIOChannel *io_channel;
+	gint r_watch_source_id;
+	gint w_watch_source_id;
+	gint ping_source_id;
+} irc_t;
 
-	const struct irc_channel_funcs *f;
-	void *data;
-} irc_channel_t;
+#include "user.h"
+#include "nick.h"
 
-struct irc_channel_funcs {
-	gboolean (*privmsg)(irc_channel_t *ic, const char *msg);
-	gboolean (*join)(irc_channel_t *ic);
-	gboolean (*part)(irc_channel_t *ic, const char *msg);
-	gboolean (*topic)(irc_channel_t *ic, const char *new_topic);
-	gboolean (*invite)(irc_channel_t *ic, irc_user_t *iu);
-	void (*kick)(irc_channel_t *ic, irc_user_t *iu, const char *msg);
-
-	gboolean (*_init)(irc_channel_t *ic);
-	gboolean (*_free)(irc_channel_t *ic);
-};
-
-typedef enum {
-	IRC_CHANNEL_USER_OP = 1,
-	IRC_CHANNEL_USER_HALFOP = 2,
-	IRC_CHANNEL_USER_VOICE = 4,
-	IRC_CHANNEL_USER_NONE = 8,
-} irc_channel_user_flags_t;
-
-typedef struct irc_channel_user {
-	irc_user_t *iu;
-	int flags;
-} irc_channel_user_t;
-
-typedef enum {
-	IRC_CC_TYPE_DEFAULT  = 0x00001,
-	IRC_CC_TYPE_REST     = 0x00002, /* Still not implemented. */
-	IRC_CC_TYPE_GROUP    = 0x00004,
-	IRC_CC_TYPE_ACCOUNT  = 0x00008,
-	IRC_CC_TYPE_PROTOCOL = 0x00010,
-	IRC_CC_TYPE_MASK     = 0x000ff,
-	IRC_CC_TYPE_INVERT   = 0x00100,
-} irc_control_channel_type_t;
-
-struct irc_control_channel {
-	irc_control_channel_type_t type;
-	struct bee_group *group;
-	struct account *account;
-	struct prpl *protocol;
-	char modes[5];
-};
-
-extern const struct bee_ui_funcs irc_ui_funcs;
-
-typedef enum {
-	IRC_CDU_SILENT,
-	IRC_CDU_PART,
-	IRC_CDU_KICK,
-} irc_channel_del_user_type_t;
-
-/* These are a glued a little bit to the core/bee layer and a little bit to
-   IRC. The first user is OTR, and I guess at some point we'll get to shape
-   this a little bit more as other uses come up. */
-typedef struct irc_plugin {
-	/* Called at the end of irc_new(). Can be used to add settings, etc. */
-	gboolean (*irc_new)(irc_t *irc);
-	/* At the end of irc_free(). */
-	void (*irc_free)(irc_t *irc);
-
-	/* Problem with the following two functions is ordering if multiple
-	   plugins are handling them. Let's keep fixing that problem for
-	   whenever it becomes important. */
-
-	/* Called by bee_irc_user_privmsg_cb(). Return NULL if you want to
-	   abort sending the msg. */
-	char* (*filter_msg_out)(irc_user_t * iu, char *msg, int flags);
-	/* Called by bee_irc_user_msg(). Return NULL if you swallowed the
-	   message and don't want anything to go to the user. */
-	char* (*filter_msg_in)(irc_user_t * iu, char *msg, int flags);
-
-	/* From storage.c functions. Ideally these should not be used
-	   and instead data should be stored in settings which will get
-	   saved automatically. Consider these deprecated! */
-	void (*storage_load)(irc_t *irc);
-	void (*storage_save)(irc_t *irc);
-	void (*storage_remove)(const char *nick);
-} irc_plugin_t;
-
-extern GSList *irc_plugins; /* struct irc_plugin */
-
-/* irc.c */
 extern GSList *irc_connection_list;
 
-irc_t *irc_new(int fd);
-void irc_set_hosts(irc_t *irc, const struct sockaddr *remote_addr, const socklen_t remote_addrlen);
-void irc_abort(irc_t *irc, int immed, char *format, ...) G_GNUC_PRINTF(3, 4);
-void irc_free(irc_t *irc);
-void irc_setpass(irc_t *irc, const char *pass);
+irc_t *irc_new( int fd );
+void irc_free( irc_t *irc );
 
-void irc_process(irc_t *irc);
-char **irc_parse_line(char *line);
-char *irc_build_line(char **cmd);
+int irc_exec( irc_t *irc, char **cmd );
+int irc_process( irc_t *irc );
+int irc_process_line( irc_t *irc, char *line );
 
-void irc_write(irc_t *irc, char *format, ...) G_GNUC_PRINTF(2, 3);
-void irc_write_all(int now, char *format, ...) G_GNUC_PRINTF(2, 3);
-void irc_vawrite(irc_t *irc, char *format, va_list params);
+void irc_vawrite( irc_t *irc, char *format, va_list params );
+void irc_write( irc_t *irc, char *format, ... );
+void irc_write_all( char *format, ... );
+void irc_reply( irc_t *irc, int code, char *format, ... );
+G_MODULE_EXPORT int irc_usermsg( irc_t *irc, char *format, ... );
+char **irc_tokenize( char *buffer );
 
-void irc_flush(irc_t *irc);
-void irc_switch_fd(irc_t *irc, int fd);
-void irc_sync(irc_t *irc);
-void irc_desync(irc_t *irc);
+void irc_login( irc_t *irc );
+void irc_motd( irc_t *irc );
+void irc_names( irc_t *irc, char *channel );
+void irc_topic( irc_t *irc, char *channel );
+void irc_umode_set( irc_t *irc, char *who, char *s );
+void irc_who( irc_t *irc, char *channel );
+void irc_spawn( irc_t *irc, user_t *u );
+void irc_join( irc_t *irc, user_t *u, char *channel );
+void irc_part( irc_t *irc, user_t *u, char *channel );
+void irc_kick( irc_t *irc, user_t *u, char *channel, user_t *kicker );
+void irc_kill( irc_t *irc, user_t *u );
+void irc_invite( irc_t *irc, char *nick, char *channel );
+void irc_whois( irc_t *irc, char *nick );
+int irc_away( irc_t *irc, char *away );
 
-int irc_check_login(irc_t *irc);
+int irc_send( irc_t *irc, char *nick, char *s, int flags );
+int irc_privmsg( irc_t *irc, user_t *u, char *type, char *to, char *prefix, char *msg );
+int irc_msgfrom( irc_t *irc, char *nick, char *msg );
+int irc_noticefrom( irc_t *irc, char *nick, char *msg );
 
-void irc_umode_set(irc_t *irc, const char *s, gboolean allow_priv);
-
-void register_irc_plugin(const struct irc_plugin *p);
-
-/* irc_channel.c */
-irc_channel_t *irc_channel_new(irc_t *irc, const char *name);
-irc_channel_t *irc_channel_by_name(irc_t *irc, const char *name);
-irc_channel_t *irc_channel_get(irc_t *irc, char *id);
-int irc_channel_free(irc_channel_t *ic);
-void irc_channel_free_soon(irc_channel_t *ic);
-int irc_channel_add_user(irc_channel_t *ic, irc_user_t *iu);
-int irc_channel_del_user(irc_channel_t *ic, irc_user_t *iu, irc_channel_del_user_type_t type, const char *msg);
-irc_channel_user_t *irc_channel_has_user(irc_channel_t *ic, irc_user_t *iu);
-struct irc_channel *irc_channel_with_user(irc_t *irc, irc_user_t *iu);
-int irc_channel_set_topic(irc_channel_t *ic, const char *topic, const irc_user_t *who);
-void irc_channel_user_set_mode(irc_channel_t *ic, irc_user_t *iu, irc_channel_user_flags_t flags);
-void irc_channel_set_mode(irc_channel_t *ic, const char *s);
-void irc_channel_auto_joins(irc_t *irc, struct account *acc);
-void irc_channel_printf(irc_channel_t *ic, char *format, ...) G_GNUC_PRINTF(2, 3);
-gboolean irc_channel_name_ok(const char *name);
-void irc_channel_name_strip(char *name);
-int irc_channel_name_cmp(const char *a_, const char *b_);
-char *irc_channel_name_gen(irc_t *irc, const char *name);
-gboolean irc_channel_name_hint(irc_channel_t *ic, const char *name);
-void irc_channel_update_ops(irc_channel_t *ic, char *value);
-char irc_channel_user_get_prefix(irc_channel_user_t *icu);
-char *set_eval_irc_channel_ops(struct set *set, char *value);
-gboolean irc_channel_wants_user(irc_channel_t *ic, irc_user_t *iu);
-
-/* irc_commands.c */
-void irc_exec(irc_t *irc, char **cmd);
-
-/* irc_send.c */
-void irc_send_num(irc_t *irc, int code, char *format, ...) G_GNUC_PRINTF(3, 4);
-void irc_send_login(irc_t *irc);
-void irc_send_motd(irc_t *irc);
-const char *irc_user_msgdest(irc_user_t *iu);
-void irc_rootmsg(irc_t *irc, char *format, ...) G_GNUC_PRINTF(2, 3);
-void irc_usermsg(irc_user_t *iu, char *format, ...) G_GNUC_PRINTF(2, 3);
-void irc_usernotice(irc_user_t *iu, char *format, ...) G_GNUC_PRINTF(2, 3);
-void irc_send_join(irc_channel_t *ic, irc_user_t *iu);
-void irc_send_part(irc_channel_t *ic, irc_user_t *iu, const char *reason);
-void irc_send_quit(irc_user_t *iu, const char *reason);
-void irc_send_kick(irc_channel_t *ic, irc_user_t *iu, irc_user_t *kicker, const char *reason);
-void irc_send_names(irc_channel_t *ic);
-void irc_send_topic(irc_channel_t *ic, gboolean topic_change);
-void irc_send_whois(irc_user_t *iu);
-void irc_send_who(irc_t *irc, GSList *l, const char *channel);
-void irc_send_msg(irc_user_t *iu, const char *type, const char *dst, const char *msg, const char *prefix);
-void irc_send_msg_raw(irc_user_t *iu, const char *type, const char *dst, const char *msg);
-void irc_send_msg_f(irc_user_t *iu, const char *type, const char *dst, const char *format, ...) G_GNUC_PRINTF(4, 5);
-void irc_send_nick(irc_user_t *iu, const char *new_nick);
-void irc_send_channel_user_mode_diff(irc_channel_t *ic, irc_user_t *iu,
-                                     irc_channel_user_flags_t old_flags, irc_channel_user_flags_t new_flags);
-void irc_send_invite(irc_user_t *iu, irc_channel_t *ic);
-void irc_send_cap(irc_t *irc, char *subcommand, char *body);
-void irc_send_away_notify(irc_user_t *iu);
-
-G_GNUC_INTERNAL void irc_send_msg_ts(irc_user_t *iu, const char *type, const char *dst, const char *msg, const char *prefix, time_t ts);
-G_GNUC_INTERNAL void irc_send_msg_raw_tags(irc_user_t *iu, const char *type, const char *dst, const char* tags, const char *msg);
-
-/* irc_user.c */
-irc_user_t *irc_user_new(irc_t *irc, const char *nick);
-int irc_user_free(irc_t *irc, irc_user_t *iu);
-irc_user_t *irc_user_by_name(irc_t *irc, const char *nick);
-int irc_user_set_nick(irc_user_t *iu, const char *new_nick);
-gint irc_user_cmp(gconstpointer a_, gconstpointer b_);
-const char *irc_user_get_away(irc_user_t *iu);
-void irc_user_quit(irc_user_t *iu, const char *msg);
-
-/* irc_util.c */
-char *set_eval_timezone(struct set *set, char *value);
-char *irc_format_timestamp(irc_t *irc, time_t msg_ts);
-G_GNUC_INTERNAL char *irc_format_servertime(irc_t *irc, time_t msg_ts);
-char *set_eval_self_messages(struct set *set, char *value);
-
-/* irc_im.c */
-void bee_irc_channel_update(irc_t *irc, irc_channel_t *ic, irc_user_t *iu);
-void bee_irc_user_nick_reset(irc_user_t *iu);
-
-/* irc_cap.c */
-void irc_cmd_cap(irc_t *irc, char **cmd);
+int buddy_send_handler( irc_t *irc, user_t *u, char *msg, int flags );
 
 #endif
Index: log.c
===================================================================
--- log.c	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ log.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,9 +1,9 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2005 Wilmer van der Gaast and others                *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
   \********************************************************************/
 
-/* Logging services for the bee                         */
+/* Logging services for the bee 			*/
 
 /*
@@ -20,6 +20,6 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
@@ -30,18 +30,17 @@
 static log_t logoutput;
 
-static void log_null(int level, const char *logmessage);
-static void log_irc(int level, const char *logmessage);
-static void log_syslog(int level, const char *logmessage);
-static void log_console(int level, const char *logmessage);
+static void log_null(int level, char *logmessage);
+static void log_irc(int level, char *logmessage);
+static void log_syslog(int level, char *logmessage);
+static void log_console(int level, char *logmessage);
 
-void log_init(void)
-{
-	openlog("bitlbee", LOG_PID, LOG_DAEMON);
+void log_init(void) {
+	openlog("bitlbee", LOG_PID, LOG_DAEMON);	
 
-	logoutput.informational = &log_null;
-	logoutput.warning = &log_null;
-	logoutput.error = &log_null;
+	logoutput.informational=&log_null;
+	logoutput.warning=&log_null;
+	logoutput.error=&log_null;
 #ifdef DEBUG
-	logoutput.debug = &log_null;
+	logoutput.debug=&log_null;
 #endif
 
@@ -49,36 +48,54 @@
 }
 
-void log_link(int level, int output)
-{
-	void (*output_function)(int level, const char *logmessage) = &log_null;
+void log_link(int level, int output) {
+	/* I know it's ugly, but it works and I didn't feel like messing with pointer to function pointers */
 
-	if (output == LOGOUTPUT_NULL) {
-		output_function = &log_null;
-	} else if (output == LOGOUTPUT_IRC) {
-		output_function = &log_irc;
-	} else if (output == LOGOUTPUT_SYSLOG) {
-		output_function = &log_syslog;
-	} else if (output == LOGOUTPUT_CONSOLE) {
-		output_function = &log_console;
+	if(level==LOGLVL_INFO) {
+		if(output==LOGOUTPUT_NULL)
+			logoutput.informational=&log_null;	
+		else if(output==LOGOUTPUT_IRC)
+			logoutput.informational=&log_irc;	
+		else if(output==LOGOUTPUT_SYSLOG)
+			logoutput.informational=&log_syslog;	
+		else if(output==LOGOUTPUT_CONSOLE) 
+			logoutput.informational=&log_console;	
 	}
-
-	if (level == LOGLVL_INFO) {
-		logoutput.informational = output_function;
-	} else if (level == LOGLVL_WARNING) {
-		logoutput.warning = output_function;
-	} else if (level == LOGLVL_ERROR) {
-		logoutput.error = output_function;
+	else if(level==LOGLVL_WARNING) {
+		if(output==LOGOUTPUT_NULL)
+			logoutput.warning=&log_null;
+		else if(output==LOGOUTPUT_IRC)
+			logoutput.warning=&log_irc;
+		else if(output==LOGOUTPUT_SYSLOG)
+			logoutput.warning=&log_syslog;
+		else if(output==LOGOUTPUT_CONSOLE)
+			logoutput.warning=&log_console;
+	}
+	else if(level==LOGLVL_ERROR) {
+		if(output==LOGOUTPUT_NULL)
+			logoutput.error=&log_null;
+		else if(output==LOGOUTPUT_IRC)
+			logoutput.error=&log_irc;
+		else if(output==LOGOUTPUT_SYSLOG)
+			logoutput.error=&log_syslog;
+		else if(output==LOGOUTPUT_CONSOLE)
+			logoutput.error=&log_console;
 	}
 #ifdef DEBUG
-	else if (level == LOGLVL_DEBUG) {
-		logoutput.debug = output_function;
+	else if(level==LOGLVL_DEBUG) {
+		if(output==LOGOUTPUT_NULL)
+			logoutput.debug=&log_null;
+		else if(output==LOGOUTPUT_IRC)
+			logoutput.debug=&log_irc;
+		else if(output==LOGOUTPUT_SYSLOG)
+			logoutput.debug=&log_syslog;
+		else if(output==LOGOUTPUT_CONSOLE)
+			logoutput.debug=&log_console;
 	}
 #endif
-	return;
+	return;	
 
 }
 
-void log_message(int level, const char *message, ...)
-{
+void log_message(int level, char *message, ... ) {
 
 	va_list ap;
@@ -89,93 +106,70 @@
 	va_end(ap);
 
-	if (level == LOGLVL_INFO) {
+	if(level==LOGLVL_INFO)
 		(*(logoutput.informational))(level, msgstring);
-	}
-	if (level == LOGLVL_WARNING) {
+	if(level==LOGLVL_WARNING) 
 		(*(logoutput.warning))(level, msgstring);
-	}
-	if (level == LOGLVL_ERROR) {
+	if(level==LOGLVL_ERROR)
 		(*(logoutput.error))(level, msgstring);
-	}
 #ifdef DEBUG
-	if (level == LOGLVL_DEBUG) {
+	if(level==LOGLVL_DEBUG)
 		(*(logoutput.debug))(level, msgstring);
-	}
 #endif
 
 	g_free(msgstring);
+	
+	return;
+}
+
+void log_error(char *functionname) {
+	log_message(LOGLVL_ERROR, "%s: %s", functionname, strerror(errno));
+	
+	return;
+}
+
+static void log_null(int level, char *message) {
+	return;
+}
+
+static void log_irc(int level, char *message) {
+	if(level==LOGLVL_ERROR)
+		irc_write_all("ERROR :Error: %s", message);
+	if(level==LOGLVL_WARNING)
+		irc_write_all("ERROR :Warning: %s", message);
+	if(level==LOGLVL_INFO)
+		irc_write_all("ERROR :Informational: %s", message);	
+#ifdef DEBUG
+	if(level==LOGLVL_DEBUG)
+		irc_write_all("ERROR :Debug: %s", message);	
+#endif	
 
 	return;
 }
 
-void log_error(const char *functionname)
-{
-	log_message(LOGLVL_ERROR, "%s: %s", functionname, strerror(errno));
-
-	return;
-}
-
-static void log_null(int level, const char *message)
-{
-	return;
-}
-
-static void log_irc(int level, const char *message)
-{
-	if (level == LOGLVL_ERROR) {
-		irc_write_all(1, "ERROR :Error: %s", message);
-	}
-	if (level == LOGLVL_WARNING) {
-		irc_write_all(0, "ERROR :Warning: %s", message);
-	}
-	if (level == LOGLVL_INFO) {
-		irc_write_all(0, "ERROR :Informational: %s", message);
-	}
+static void log_syslog(int level, char *message) {
+	if(level==LOGLVL_ERROR)
+		syslog(LOG_ERR, "%s", message);
+	if(level==LOGLVL_WARNING)
+		syslog(LOG_WARNING, "%s", message);
+	if(level==LOGLVL_INFO)
+		syslog(LOG_INFO, "%s", message);
 #ifdef DEBUG
-	if (level == LOGLVL_DEBUG) {
-		irc_write_all(0, "ERROR :Debug: %s", message);
-	}
-#endif
-
-	return;
-}
-
-static void log_syslog(int level, const char *message)
-{
-	if (level == LOGLVL_ERROR) {
-		syslog(LOG_ERR, "%s", message);
-	}
-	if (level == LOGLVL_WARNING) {
-		syslog(LOG_WARNING, "%s", message);
-	}
-	if (level == LOGLVL_INFO) {
-		syslog(LOG_INFO, "%s", message);
-	}
-#ifdef DEBUG
-	if (level == LOGLVL_DEBUG) {
+	if(level==LOGLVL_DEBUG)
 		syslog(LOG_DEBUG, "%s", message);
-	}
 #endif
 	return;
 }
 
-static void log_console(int level, const char *message)
-{
-	if (level == LOGLVL_ERROR) {
+static void log_console(int level, char *message) {
+	if(level==LOGLVL_ERROR)
 		fprintf(stderr, "Error: %s\n", message);
-	}
-	if (level == LOGLVL_WARNING) {
+	if(level==LOGLVL_WARNING)
 		fprintf(stderr, "Warning: %s\n", message);
-	}
-	if (level == LOGLVL_INFO) {
+	if(level==LOGLVL_INFO)
 		fprintf(stdout, "Informational: %s\n", message);
-	}
 #ifdef DEBUG
-	if (level == LOGLVL_DEBUG) {
+	if(level==LOGLVL_DEBUG)
 		fprintf(stdout, "Debug: %s\n", message);
-	}
 #endif
-	/* Always log stuff in syslogs too. */
-	log_syslog(level, message);
 	return;
 }
Index: log.h
===================================================================
--- log.h	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ log.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,6 +1,6 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2005 Wilmer van der Gaast and others                *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
   \********************************************************************/
 
@@ -20,6 +20,6 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
@@ -44,9 +44,9 @@
 
 typedef struct log_t {
-	void (*error)(int level, const char *logmessage);
-	void (*warning)(int level, const char *logmessage);
-	void (*informational)(int level, const char *logmessage);
+	void (*error)(int level, char *logmessage);
+	void (*warning)(int level, char *logmessage); 
+	void (*informational)(int level, char *logmessage);
 #ifdef DEBUG
-	void (*debug)(int level, const char *logmessage);
+	void (*debug)(int level, char *logmessage);
 #endif
 } log_t;
@@ -54,6 +54,6 @@
 void log_init(void);
 void log_link(int level, int output);
-void log_message(int level, const char *message, ...) G_GNUC_PRINTF(2, 3);
-void log_error(const char *functionname);
+void log_message(int level, char *message, ...);
+void log_error(char *functionname);
 
 #endif
